# Coveo Icon Component (CoveoIcon)

The Icon component outputs the corresponding icon for a given file type. The component searches for a suitable icon from those available in the Coveo JavaScript Search Framework. If the component finds no suitable icon, it instead outputs a generic icon.

This component is a result template component (see Result Templates).

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- conditions
- labelValue
- small
- value
- withLabel

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### conditions

conditions: IFieldConditionOption[]

- Defined in ui/Icon/Icon.ts :104

A field-based condition that must be satisfied by the query result item for the component to be rendered.

Note: This option uses a distinctive markup configuration syntax allowing multiple conditions to be expressed. Its underlying logic is the same as that of the field value conditions mechanism used by result templates.

Examples: Render the component if the query result item's @documenttype field value is Article or Documentation.

    <div class="CoveoIcon" data-field="@author" data-condition-field-documenttype="Article, Documentation"></div>

Render the component if the query result item's @documenttype field value is anything but Case.

    <div class="CoveoIcon" data-field="@author" data-condition-field-not-documenttype="Case"></div>

Render the component if the query result item's @documenttype field value is Article, and if its @author field value is anything but Anonymous.

    <div class="CoveoIcon" data-field="@author" data-condition-field-documenttype="Article" data-condition-field-not-author="Anonymous"></div>

Default value is `undefined`.

### labelValue

labelValue: string

- Defined in ui/Icon/Icon.ts :81

Specifies what text to display as the icon caption/label.

Default value is `undefined`, which means that the Coveo JavaScript Search Framework determines what text the icon needs to display depending on the result file type.

Markup configuration example(s) :

    data-label-value='foo'

### small

small: boolean

- Defined in ui/Icon/Icon.ts :60

Specifies whether the Icon component should output the smaller version of the icon instead of the regular one.

Default value is `undefined`.

Markup configuration example(s) :

    data-small='true'
    data-small='false'

### value

value: string

- Defined in ui/Icon/Icon.ts :53

Specifies the value that the Icon component should output as its CSS class instead of the auto-selected value.

Default value is `undefined`, which means that the Coveo JavaScript Search Framework outputs a suitable icon depending on the result file type.

Markup configuration example(s) :

    data-value='foo'

### withLabel

withLabel: boolean

- Defined in ui/Icon/Icon.ts :73

Specifies whether the Icon component should force the output icon to display its caption/label.

Note:

> Due to limited screen real estate, setting this option to `true` has no effect on icons used inside Coveo for Salesforce Insight Panels.

Default value is `undefined`, which means that the Coveo JavaScript Search Framework determines whether the icon needs to display a caption/label depending on the result file type.

Markup configuration example(s) :

    data-with-label='true'
    data-with-label='false'

## Constructors

### constructor

- new Icon(element: HTMLElement, options?: IIconOptions, bindings?: IComponentBindings, result?: IQueryResult): Icon

- Overwrites Component.constructor

  - Defined in ui/Icon/Icon.ts :105

  Creates a new Icon component.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component.

  - ##### Optional options: IIconOptions

    The options for the Icon component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  - ##### Optional result: IQueryResult

    The result to associate the component with.

  #### Returns Icon